**Projekt Alumnihub**

**Lastenheft**

**Inhaltsverzeichnis**

- [Zweck des Dokumentes und Scope](#zweck-des-dokumentes-und-scope)
  - [Zweck des Dokumentes](#zweck-des-dokumentes)
  - [Scope und Abgrenzung](#scope-und-abgrenzung)
- [Grundlagen](#grundlagen)
  - [Verwendete Normen und mitgeltende Dokumente](#verwendete-normen-und-mitgeltende-dokumente)
- [Hardwareanforderungen](#hardwareanforderungen)
  - [Allgemeine Anforderunge](#allgemeine-anforderunge)
  - [Anforderungen an Server](#anforderungen-an-server)
  - [Anforderungen an den Bedienrechner / das mobile Endgerät](#anforderungen-an-den-bedienrechner--das-mobile-endgerät)
  - [Anforderungen an das Backup, Recovery und Desaster-Recovery](#anforderungen-an-das-backup-recovery-und-desaster-recovery)
  - [Anforderungen an Redundanz und Verfügbarkeit](#anforderungen-an-redundanz-und-verfügbarkeit)
    - [Redundanzeigenschaften](#redundanzeigenschaften)
    - [Verfügbarkeitsanforderungen](#verfügbarkeitsanforderungen)
  - [Schnittstellen](#schnittstellen)
    - [Schnittstellen zu eigenen Systemen](#schnittstellen-zu-eigenen-systemen)
    - [Schnittstellen zu anderen Systemen](#schnittstellen-zu-anderen-systemen)
- [Anforderungen an die Software](#anforderungen-an-die-software)
  - [Allgemeine Anforderungen](#allgemeine-anforderungen)
  - [Zugriffsverwaltung](#zugriffsverwaltung)
  - [Hall of Fame (Phase 2)](#hall-of-fame-phase-2)
  - [Firmen und Jobstellenmarkt (Phase 2)](#firmen-und-jobstellenmarkt-phase-2)
  - [Premiumbereich (Phase 2)](#premiumbereich-phase-2)
  - [Auswertungen](#auswertungen)
  - [Datenschutz \& Informationssicherheit](#datenschutz--informationssicherheit)
  - [Schwarzes Brett (Phase 2)](#schwarzes-brett-phase-2)
  - [Anmeldetool für Treffen](#anmeldetool-für-treffen)
  - [Profilverwaltung](#profilverwaltung)
- [Datenbank](#datenbank)
- [Dokumentation](#dokumentation)
  - [Projektdokumentation](#projektdokumentation)


# Zweck des Dokumentes und Scope

## Zweck des Dokumentes

*Der Zweck dieses Dokuments ist die Beschreibung der Anforderungen an die Hardware und an die Web-Anwendung für den Absolventenverband.*

*Das Ziel dieses Lastenhefts ist die detaillierte Beschreibung der Anforderungen an die zu entwickelnde Applikation für den Absolventenverband. Diese Applikation soll es ermöglichen, Absolventen zu verwalten, Veranstaltungen zu organisieren, eine Jobbörse zu integrieren und die Kommunikation innerhalb des Verbands zu verbessern. Dabei sollen verschiedene Rollen- und Berechtigungskonzepte berücksichtigt werden, und die Applikation soll in mehreren Phasen umgesetzt werden, wobei Funktionalitäten priorisiert werden.*

*Die Applikation soll eine zentrale Plattform für Absolventen sein, über die sie sich registrieren, austauschen und auf relevante Angebote zugreifen können. Kernkomponenten wie das Anmeldetool für Treffen, die Hall of Fame und der Jobstellenmarkt werden ergänzt durch optionale Funktionen wie die Integration von LinkedIn für Profilabgleiche und einen Premiumbereich für zahlende Nutzer.*

## Scope und Abgrenzung

*Abgrenzung / Was kommt in Phase 1 hinein?*

*Das Projekt umfasst die Entwicklung der Applikation mit den Funktionen für die Verwaltung von Absolventenprofilen, die Organisation von Veranstaltungen, die Darstellung der Hall of Fame, sowie die Integration eines Firmen- und Jobstellenmarkts. Die Zugriffsverwaltung sowie die Sicherheit der Daten (DSGVO-konform) sind wesentliche Bestandteile. Optional sind Erweiterungen wie ein Schülerzugang oder die Integration eines CMS für redaktionelle Beiträge. Nicht in den Scope fallen jedoch Zahlungsprozesse für den Premiumbereich und externe Lösungen für den Eventkalender (V-Calendar, V-Event), die separat betrachtet werden.*

# Grundlagen

## Verwendete Normen und mitgeltende Dokumente

*Die bestehenden Gesetze und technischen Regelwerke sind zu beachten. Insbesondere sind im Kontext des gegenständlichen Dokumentes die folgenden Normen zu berücksichtigen:*

*Die Applikation muss unter Beachtung der folgenden Normen und rechtlichen Vorgaben entwickelt werden:*

*- DSGVO (Datenschutz-Grundverordnung): Es dürfen nur notwendige personenbezogene Daten gespeichert werden, wie E-Mail, Telefonnummer und Land/Bundesland​. Ein Opt-In-Verfahren wird für die Speicherung von Nutzerdaten angewendet, und es muss die Möglichkeit zur Löschung von Einträgen geben (Rückwirkend möglich)*
*- NIS 2 Richtlinie (Netz- und Informationssicherheit); Als digitaler Dienstanbieter müssen Sicherheitsanforderungen eingehalten werden. Besonders die sichere Aufbewahrung und Verwaltung von Nutzerdaten, sowie der Schutz vor Datenverlust sind hier entscheidend​.*

*Weitere Bestimmungen, wie die Handhabung der Benutzerrechte und Datenschutzrichtlinien im Zusammenhang mit Drittanbieter-APIs (z. B. LinkedIn-OAuth), müssen ebenfalls geprüft und eingehalten werden.*

# Hardwareanforderungen

## Allgemeine Anforderunge

*Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.*

| **300 aktuellen Nutzern**  <br>Das System muss mindestens 300 aktuelle Benutzer unterstützen, die das System administrieren, bearbeiten und nutzen können. Nicht jeder Benutzer benötigt ein eigenes Profil. | HW-1 |
| --- | --- |
| **ca. 50 Zugriffe / Tag**  <br>Das System muss in der Lage sein, ca. 50 aktive Benutzer pro Tag (tendenziell steigend) zu unterstützen, ohne dass die Systemleistung beeinträchtigt wird. Die Systemressourcen sollten ausreichend dimensioniert sein, um eine reibungslose und effiziente Nutzung durch die Benutzer zu gewährleisten. | HW-2 |
| **Einfach skalierbar**  <br>Das System muss einfach skaliert werden können, um aufsteigende Anforderungen und Benutzerzahlen reagieren zu können. Dies sollte ohne wesentliche Änderungen an der Systemarchitektur oder -Infrastruktur möglich sein, um eine flexible und kosteneffiziente Anpassung an zukünftige Bedürfnisse zu ermöglichen. | HW-3 |

## Anforderungen an Server

Phase 2: Schülerzugang braucht mehr Nutzer…. Zugriffe / Tag steigen auch.

<table><tbody><tr><th><p><strong>Die Anwendung wird auf einem Cloud-Server betrieben, der skalierbar ist, um den Anforderungen eines wachsenden Benutzerstamms gerecht zu werden.</strong></p></th><th><p>HW-4</p></th></tr><tr><td><p><strong>Hochverfügbar: 99.5%</strong></p><p>Das System muss eine Verfügbarkeit von mindestens 99,5% aufweisen. Dies bedeutet, dass das System innerhalb eines Jahres höchstens 43,8 Stunden (0,5% von 8760 Stunden) nicht verfügbar sein darf.</p></td><td><p>HW-5</p></td></tr><tr><td><p><strong>Datenbank und Anwendung muss redundant und gegen Ausfall eines Servers gesichert sein.</strong></p><p>Die Datenbank und die Anwendung müssen redundant und gegen Ausfälle gesichert sein, um Datenverluste und Systemausfälle zu vermeiden. Dies umfasst die Implementierung von:</p><ul><li>Datenbankreplikation</li><li>Regelmäßige Backups und Datenwiederherstellung</li></ul></td><td><p>HW-6</p></td></tr><tr><td><p><strong>.Net Runtime muss unterstützt werden</strong><br>Die Anwendung muss die .NET Runtime unterstützen, um eine reibungslose Ausführung von .NET-basierten Anwendungen zu ermöglichen.</p></td><td><p>HW-7</p></td></tr><tr><td><p><strong>Sicherheit und administrativer Zugriff:</strong></p><p>Der Zugriff auf die Anwendung und die Infrastruktur muss jederzeit gegeben sein. Dies kann durch die Implementierung von:</p><ul><li>SSH-Zugriff für Administratoren</li><li>VPN-Verbindung (Virtual Private Network) für eine sichere und verschlüsselte Verbindung</li><li>Zugriffskontrolle und Authentifizierung, um den Zugriff auf autorisierte Personen zu beschränken</li></ul><p>erreicht werden.</p></td><td><p>HW-8</p></td></tr></tbody></table>

## Anforderungen an den Bedienrechner / das mobile Endgerät

| **Moderner Browser (Chrome, Firefox, Safari und Edge)** | HW-9 |
| --- | --- |
| **JavaScript muss aktiv sein.** | HW-10 |
| **Internetverbindung (5 MBit/s)** | HW-11 |

## Anforderungen an das Backup, Recovery und Desaster-Recovery

| **Automatisierte Datensicherung**<br><br>Zur Erhöhung der Datensicherheit soll über das Komplettsystem eine automatisierte Datensicherung erfolgen. (Versionen / Binaries der Anwendungen, Konfigurationsdateien und Nutzerdaten) | HW-12 |
| --- | --- |
| **Wiederherstellungszeitraum**<br><br>Die Wiederherstellung des Servers im Falle eines Ausfalls (des Rechenzentrums) muss innerhalb von **einem Tag** gewährleistet sein. Also nach 24 Stunden muss das System wieder in einen benutzbaren Zustand gebracht werden | HW-13 |
| **Dokumentation zum Wiederherstellungsverfahren muss vorhanden sein.**<br><br>Schritt für Schritt Anweisungen zum Wiederherstellen des Systems | HW-14 |

## Anforderungen an Redundanz und Verfügbarkeit

### Redundanzeigenschaften

Redundanzeigenschaften Bespr. Mit Hr. Prof. Gürth

|     | RED-1 |
| --- | --- |
|     | RED-2 |
|     | RED-3 |

### Verfügbarkeitsanforderungen

| **99% / Jahr (87.6h)**<br><br>Das System soll weniger als 90 Stunden im Jahr ausfallen. | RED-4 |
| --- | --- |
| **Wiederherstellungszeit: the next business day**<br><br>Das System soll bis zum übernächsten Werktag wieder in einen Nutzbaren zustand bringbar sein. | RED-5 |
|     |     |

## Schnittstellen

### Schnittstellen zu eigenen Systemen

| RestAPI (Frontend / Backend)<br><br>Zwischen Datenbank und C#<br><br>Die Umsetzung einer RESTAPI umfasst die Planung von Endpunkten, Backend-Entwicklung, Datenbankanbindung | SnT-1 |
| --- | --- |

### Schnittstellen zu anderen Systemen

| SMTP (Email versand)<br><br>C# (Backend) zum Mailserver<br><br>Die Umsetzung von SMTP für den E-Mail-Versand umfasst die Konfiguration eines SMTP-Servers, die Erstellung von E-Mail-Nachrichten im richtigen Format, die Verwendung von SMTP-Befehlen (wie EHLO, MAIL FROM, RCPT TO, DATA), das Senden der E-Mail über den Server. | SnT-2 |
| --- | --- |
| LinkedÌn OAuth (Phase 2, oder später)<br><br>Backend zu LinkedIn<br><br>Die Umsetzung von LinkedIn OAuth für die Authentifizierung umfasst die Registrierung einer Anwendung im LinkedIn Developer Portal, die Umleitung des Benutzers zur LinkedIn-Login-Seite zur Zustimmung, das Erhalten eines Zugriffstokens durch den Austausch eines Autorisierungscodes, das Stellen von API-Anfragen mit dem Zugriffstoken und das sichere Management des Tokens zur Optimierung der Benutzererfahrung. | SnT -3 |

# Anforderungen an die Software

## Allgemeine Anforderungen

| Mit allen Modernen Webbrowser kompatibel (Chrome, Firefox, Safari und Edge)<br><br>Dass die Website oder Webanwendung so entwickelt wird, dass sie in den gängigsten und aktuellen Webbrowsern einwandfrei funktioniert. | SW-1 |
| --- | --- |
| Barrierefreiheit (WAI-ARIA-Standard) ...<br><br>Bezieht sich auf die Verwendung von ARIA-Attributen, um Webinhalte und für Menschen mit Behinderungen zugänglich zu machen. Um insbesondere dynamische Inhalte und moderne interaktive Webelemente (wie Dropdown-Menüs, Sliders,) für Menschen mit Einschränkungen nutzbar zu machen, die Screenreader oder andere Hilfstechnologien verwenden. | SW-2 |

## Zugriffsverwaltung

<table><tbody><tr><th><p><strong>Benutzername und Passwort Authentifizierung</strong></p><p>Frontend:</p><p>Benutzername- und Passwort-Authentifizierung auf die Interaktion des Benutzers mit der Weboberfläche. Es geht darum, wie der Benutzer seine Anmeldeinformationen eingibt, wie diese Daten sicher an den Server übermittelt werden und wie der Benutzer nach erfolgreicher Authentifizierung auf die geschützten Teile der Anwendung zugreifen kann.</p><p>Backend:</p><p>Überprüft die empfangenen Anmeldedaten, in dem er nach vorhandenen Benutzernamen sucht. Anschließend wird das eingegebene Passwort mit den Daten in der Datenbank überprüft.</p></th><th><p>ZUG-1</p></th></tr><tr><td><p><strong>Passwort zurücksetzen</strong></p><p>Frontend:</p><p>Das Zurücksetzen des Passworts im<strong> Frontend </strong>einer Anwendung ermöglicht es den Benutzern, ihr Passwort zu ändern, falls sie es vergessen haben oder aus anderen Gründen ein neues Passwort festlegen möchten.</p><p>Backend:</p><p>Das neu festgelegte Passwort überschreibt den dazugehörigen Datenbankeintrag. Der Link zum Passwortreset, sofern man sich ganz aus der Applikation ausgesperrt hat, wird per E-Mail zugestellt.</p></td><td><p>ZUG-2</p></td></tr><tr><td><p><strong>Rollen</strong></p><p>Frontend:</p><p>Verwaltung von Benutzerrechten und Zugriffssteuerung innerhalb einer Webanwendung. In einer typischen Anwendung können Benutzer unterschiedliche Rollen haben, die bestimmte Berechtigungen definieren. Diese Rollen beeinflussen, welche Teile der Anwendung für den Benutzer sichtbar sind oder welche Aktionen er ausführen darf.</p><p>Backend:</p><p>Die Rollen erlauben es Benutzern verschiedene Berechtigungen zu erlangen. Hierfür muss im Backend ein Konzept zur Verteilung und Überprüfung von Rollen implementiert werden.</p></td><td><p>ZUG-3</p></td></tr><tr><td><p><strong>Benutzerverwaltung (für Admins)</strong></p><p>Frontend:</p><p>Die Benutzerverwaltung für Administratoren in einer Webanwendung bezieht sich auf die Funktionen, die es Administratoren ermöglichen, Benutzerkonten zu erstellen, zu bearbeiten, zu löschen und deren Berechtigungen zu verwalten.</p><p>Backend:</p><p>Alle Einträge, die in der Weboberfläche (Admin-Bereich) geändert werden, werden übers Backend in der DB gespeichert, hier muss man ganz Besonders auf die Rechteverteilung aufpassen, dass keine ungewollten Änderungen von dritten eingetragen werden.</p></td><td><p>ZUG-4</p></td></tr><tr><td><p><strong>Einladung an die EDU-Adresse (Phase 2)</strong></p><p>Frontend:</p><p>Im Frontend können Benutzer Einladungen an E-Mail-Adressen versenden, indem sie eine Adresse in ein Eingabefeld eingeben und auf „Einladen“ klicken. Die Anwendung überprüft die E-Mail-Adresse und sendet sie dann an das Backend, das eine Einladung generiert und per E-Mail verschickt.</p><p>Backend:</p><p>Es werden alle nötigen Schritte für die Erstellung einer Einladung durchgeführt, damit diese dann per E-Mail versendet werden kann.</p></td><td><p>ZUG-5</p></td></tr><tr><td><p><strong>Magic Link Authentifizierung</strong></p><p>Frontend:</p><p>Die Magic Link Authentifizierung ist eine Methode der Benutzeranmeldung, bei der anstelle eines Passworts ein einmaliger Login-Link an die E-Mail-Adresse des Benutzers gesendet wird. Wenn der Benutzer auf diesen Link klickt, wird er automatisch und sicher in die Anwendung eingeloggt.</p><p>Backend:</p><p>Ein potenzieller Benutzer bekommt per E-Mail einen Link zugesendet, womit er sich authentifizieren kann.</p></td><td><p>ZUG-6</p></td></tr><tr><td><p><strong>2FA Authentifizierung (Phase 2)</strong></p><p>Frontend:</p><ul><li>Erste Anmeldung: Der Benutzer gibt seinen Benutzernamen und sein Passwort im Frontend ein.</li><li>2FA-Code-Anforderung: Nach erfolgreicher Passworteingabe fordert die Anwendung einen zweiten Faktor an, z. B. einen 6-stelligen Code, der per SMS, E-Mail oder einer Authenticator-App (z. B. Google Authenticator) generiert wird.</li><li>Code-Eingabe: Der Benutzer gibt den Code im Frontend ein.</li><li>Verifizierung: Das Frontend sendet den Code zur Verifizierung an das Backend.</li><li>Zugriff gewähren: Bei korrekter Codeeingabe erhält der Benutzer Zugriff auf die Anwendung.</li></ul><p>Backend:</p><p>Nach erfolgreicher Eingabe der Anmeldedaten wird über eine andere Kommunikationsoberfläche ein Code übermittelt auf einem anderen Gerät generiert, der wiederum eingegeben werden muss, um seine Identität zu bestätigen.</p></td><td><p>ZUG-7</p></td></tr><tr><td><p><strong>OAuth (Phase 2)</strong></p><p>Frontend:</p><ul><li><strong>Anmeldelink</strong>: Der Benutzer klickt auf einen Login-Button, und das Frontend leitet ihn zur OAuth-Provider-Seite (z. B. Google) weiter.</li><li><strong>Autorisierung</strong>: Der Benutzer meldet sich an und erlaubt der Anwendung Zugriff auf bestimmte Daten.</li><li><strong>Token-Erhalt</strong>: Der OAuth-Provider leitet den Benutzer zurück zur Anwendung mit einem Access Token in der URL.</li><li><strong>API-Zugriff</strong>: Das Frontend speichert das Token (meist im Speicher des Browsers) und verwendet es, um direkt auf API-Ressourcen zuzugreifen.</li></ul><p>Backend:</p><p>Authentifizierung mittels LinkedIn Account. Hierfür muss im Backend ein Mapping geführt werden, welcher LinkedIn Account, zu welchem von unseren Accounts gehört. In einer weiteren Ausbaustufe kann man vielleicht gleich das ganze Profil von LinkedIn mit dem eigenen Abgleichen.</p></td><td><p>ZUG-8</p></td></tr></tbody></table>

## Hall of Fame (Phase 2)

| PDF-Generierung<br><br>Frontend:  <br>Die PDF-Generierung im Frontend der Hall of Fame für Treffen ermöglicht es Nutzern, ihre persönlichen Erfolge in einem ansprechenden Dokument festzuhalten. Jedes PDF enthält ein Bild der Person sowie eine Übersicht über ihre Schullaufbahn, berufliche Stationen und besondere Leistungen. Diese Dokumente können dann ausgedruckt und aufgehängt werden | HoF-1 |
| --- | --- |
| Online Hall of Fame<br><br>Frontend:  <br>Die Online Hall of Fame im Frontend für Treffen bietet eine Plattform, auf der Nutzer ihre Erfolge und besonderen Leistungen präsentieren können. | HoF-2 |
| OptIn Modell für Benutzer<br><br>Frontend:  <br>Das Opt-In-Modell im Frontend der Hall of Fame für Treffen ermöglicht es Nutzern, aktiv zu entscheiden, ob sie in die Ruhmeshalle aufgenommen werden möchten. Durch eine einfache Zustimmung können sie ihre Erfolge und Beiträge sichtbar machen, während sie gleichzeitig die Kontrolle über ihre Daten behalten und sicherstellen, dass nur die gewünschten Informationen geteilt werden. | HoF-3 |
| Löschantrag<br><br>Frontend:  <br>Im Frontend der Hall of Fame für Treffen haben Nutzer die Möglichkeit, einen Löschantrag zu stellen, um ihre Einträge zu entfernen oder bestimmte Informationen zu löschen. Diese Funktion bietet den Nutzern die Kontrolle über ihre Präsenz und ermöglicht es ihnen, ihre Daten nach Bedarf anzupassen, während sie gleichzeitig die Möglichkeit haben, ihre Erfolge zu verwalten. | HoF-4 |

## Firmen und Jobstellenmarkt (Phase 2)

| Agenturschnittstellen (API & GUI) | JOB-1 |
| --- | --- |
| Job / Mitarbeiterbörse / Praktikabörse | JOB-2 |
| Privatsphäre Einstellungen | JOB-3 |

## Premiumbereich (Phase 2)

| Verwaltung der Premiumkunden<br><br>Die Verwaltung eines Premium-Kunden umfasst die Identifizierung und Segmentierung, das Erstellen eines individuellen Profils, das Anbieten maßgeschneiderter Dienstleistungen, regelmäßige Kommunikation, exklusive Angebote, das Sammeln von Feedback und die Überwachung der Kundenzufriedenheit. | PRE-1 |
| --- | --- |
| Ingenieurantrag<br><br>Ein Ingenieurantrag umfasst die Vorbereitung der Unterlagen, das Ausfüllen des Antragsformulars, die Einreichung bei der Behörde, die Prüfung und Genehmigung des Antrags sowie die Dokumentation für zukünftige Referenzen. | PRE-2 |
| Matura & Klassentreffen organisieren<br><br>Die Organisation eines Matura- und Klassentreffens umfasst die Festlegung von Datum und Ort, die Erstellung einer Gästeliste, das Versenden von Einladungen, die Planung des Programms und die Koordination von Verpflegung und Dekoration. | PRE-3 |

## Auswertungen

Mehr Prosa (Unterscheidung Phase 1 & 2)

| **Dashboard**<br><br>Frontend:  <br>Zeige die letzten Anmeldeaktivitäten und biete schnelle Optionen zur Sicherheitsverwaltung. Ermögliche Benachrichtigungen bei neuen Login-Versuchen und erleichtere den Zugriff auf Sicherheitsfunktionen.<br><br>Backend:<br><br>Ein Backend-Dashboard bündelt Systemdaten wie Nutzeraktivität, Serverstatus und Verkaufszahlen in Echtzeit. Es visualisiert KPIs über Diagramme und Tabellen, ermöglicht schnelle Analysen und unterstützt präzise Entscheidungen. Durch Zugriffsrechte und performante Datenbanken bleibt das Dashboard sicher und effizient – die zentrale Kontrollstelle für Systemauswertungen. | AUS-1 |
| --- | --- |
| Auswertungen erstellen<br><br>Frontend:  <br>Erstelle präzise Auswertungen deiner Anmeldedaten: Analysiere Login-Häufigkeit, erkenne verdächtige Aktivitäten und gewinne Einblicke in Nutzerverhalten. Optimiere deine Sicherheitsstrategie<br><br>Backend:<br><br>Für Auswertungen im Backend sind strukturierte Daten, Filter und Algorithmen zur KPI-Berechnung nötig. Diagramme und Tabellen visualisieren die Ergebnisse. Zugriffsrechte sichern die Daten, eine performante Datenbank sorgt für schnelle Analysen – so werden Rohdaten in präzise Systemauswertungen verwandelt. | AUS-2 |
| Auswertugnen erstellen 2 (Phase 2)<br><br>Frontend:  <br>Login-Standorte und verwendete Geräte aufzeigen. Finde heraus, zu welchen Zeiten die meisten Anmeldungen stattfinden und entdecke potenzielle Sicherheitslücken durch Vergleich der Nutzeraktivitäten. Erhalte zudem detaillierte Statistiken zu fehlgeschlagenen Login-Versuchen und häufig genutzten Wiederherstellungsfunktionen, um gezielt Sicherheitsmaßnahmen zu verbessern.<br><br>Backend:<br><br>Für Backend-Auswertungen benötigt man zuverlässige Datenquellen, Filter und Algorithmen zur Berechnung von Metriken. Eine schnelle Datenbank ermöglicht effiziente Verarbeitung, Visualisierungstools wandeln Ergebnisse in Diagramme und Tabellen um. Zugriffsrechte sichern die Daten – so entsteht eine präzise und sichere Analysebasis. | AUS-3 |
| Chart generierung (Phase 2)<br><br>Frontend:  <br>Erstelle anschauliche Charts zu Anmeldedaten: Visualisiere Login-Zeiten, regionale Verteilungen und die Anzahl erfolgreicher sowie fehlgeschlagener Anmeldeversuche. Gewinne schnell wertvolle Einblicke in Nutzeraktivitäten und erkenne Trends auf einen Blick.<br><br>Backend:<br><br>Für die Chart-Generierung im Backend benötigt man Rohdaten, die kontinuierlich aus Datenquellen geladen und gefiltert werden. Algorithmen verdichten diese Daten und bereiten sie in aggregierter Form auf. Eine Charting-Bibliothek übernimmt die Visualisierung und wandelt Daten in Balken-, Linien- oder Kreisdiagramme um. Caching sorgt dabei für Geschwindigkeit, und Zugriffsrechte schützen die Daten. Das Ergebnis: klare, visuell aufbereitete Informationen für schnelle Entscheidungen. | AUS-4 |

## Datenschutz & Informationssicherheit

| **DSGVO-Konform**<br><br>Dass man die Anforderungen der Datenschutz-Grundverordnung (DSGVO) der Europäischen Union erfüllt. Die DSGVO ist eine Verordnung, die darauf abzielt, den Schutz personenbezogener Daten zu stärken und die Kontrolle über die Verwendung und Verarbeitung solcher Daten zurück in die Hände der betroffenen Personen zu legen. | DSc-1 |
| --- | --- |
| **Informationssicherheit**<br><br>Bezeichnet den Schutz von Informationen vor verschiedenen Bedrohungen, um deren Vertraulichkeit, Integrität und Verfügbarkeit zu gewährleisten. Ziel ist es, dass Daten vor unbefugtem Zugriff, Verlust, Missbrauch oder Zerstörung geschützt sind. Alle Daten müssen im Backend geschützt werden. (Serverseitige validierung jedes Requests...) | DSc-2 |

## Schwarzes Brett (Phase 2)

| **Feed**<br><br>Eine Seite auf den Mitteilungen und Ankündigungen gemacht werden. Hier kann man Events anzeigen lassen, Posts anderer Mitglieder usw. | ScB-1 |
| --- | --- |
| **Posten**<br><br>Jeder darf posten, solange ihm in der Vergangenheit dieses Privileg nicht weggenommen wurde. Diese Posts werden dann in dem Feed angezeigt. Ein Post kann eine Sichbarkeitsstufe haben (standardmäßig: öffentlich = jeder angemeldete Benutzer) | ScB-2 |
| **Werbung**<br><br>Firmen können Job Inserate schalten, Diplomarbeitskooperationen anbieten usw. Wir stellen die Schnittstelle für diese Firmen bereit, aber um die Abrechnung muss sich gesondert jemand anderer kümmern | ScB-3 |
| **Meldungsvorgang**<br><br>Man kann unangemessene Inhalte melden, diese Meldungen werden dann von Hand durchgeschaut, ob diese den Regeln widersprechen, und kann dem Benutzer über eine Rollenänderung das Privileg des Postens / Interagieren mit anderen Nutzern auf der Seite entfernt werden. | ScB-4 |

## Anmeldetool für Treffen

| Event erstellen<br><br>Frontend:  <br>Erstelle gezielte Events rund um die Anmeldung: aktiviere Erinnerungen zur Passwortaktualisierung oder plane Warnungen bei mehrfach fehlgeschlagenen Anmeldungen. So behältst du die Kontrolle über alle sicherheitsrelevanten Ereignisse.<br><br>Backend:<br><br>Für die Event-Erstellung im Anmeldetool-Backend benötigt man eine Eingabemaske, eine Datenbank zur Speicherung der Eventdaten und Algorithmen zur Verwaltung von Anmeldungen. Zugriffsrechte sichern die Bearbeitung, und automatische Bestätigungen erleichtern die Teilnehmerverwaltung. | AfT-1 |
| --- | --- |
| Einladungen verschicken<br><br>Frontend:  <br>Versende Einladungen für neue Nutzer direkt über das Anmelde-Tool: Ermögliche einfachen Zugang, verfolge den Einladungsstatus und erhalte Benachrichtigungen bei erfolgreicher Anmeldung.<br><br>Backend:<br><br>Für das Versenden von Einladungen im Backend werden Eventdaten aus der Datenbank abgerufen, personalisierte Einladungen erstellt und per E-Mail oder SMS verschickt. Eine API für den Nachrichtentransport und Zugriffsrechte zur Verwaltung sind notwendig. | AfT-2 |
| Einladung beantworten (zu/absagen)<br><br>Frontend:  <br>Antworte direkt auf Einladungen: Nimm Einladungen mit einem Klick an oder lehne sie ab. Verwalte deine offenen Einladungen zentral und behalte den Überblick über deine Zugänge – sicher und unkompliziert.<br><br>Backend:<br><br>Für das Beantworten von Einladungen im Backend benötigt man eine Datenbank, um die Teilnahmeantworten (Zusage/Absage) zu speichern. Ein Algorithmus verarbeitet die Rückmeldungen und aktualisiert den Eventstatus. Benachrichtigungen informieren den Organisator über Änderungen, während Zugriffsrechte sicherstellen, dass nur berechtigte Teilnehmer ihre Antwort einreichen können. | AfT-3 |
| Kategorisierung (Phase 2)<br><br>Frontend:  <br>Die Kategorisierung der Anmeldetools für Treffen ermöglicht eine schnelle Auswahl zwischen „Neue Veranstaltung erstellen“, „An Treffen teilnehmen“ und „Veranstaltungen verwalten“. So wird der Anmeldeprozess intuitiv und effizient. Die Kategorisierung im Frontend der Anmeldetools für Treffen ermöglicht es Nutzern, Veranstaltungen übersichtlich zu filtern und schnell zu erkennen, wer das Event erstellt hat.<br><br>Backend:<br><br>ür die Kategorisierung im Backend eines Anmeldetools werden Kategorien in der Datenbank definiert und mit den Events verknüpft. Ein Algorithmus ordnet jedes Event der entsprechenden Kategorie zu, basierend auf festgelegten Kriterien. Eine benutzerfreundliche Schnittstelle ermöglicht das Hinzufügen oder Bearbeiten von Kategorien. Zugriffsrechte stellen sicher, dass nur autorisierte Nutzer Änderungen vornehmen können. | AfT-4 |
| Zielgruppenfilter (Phase 2)<br><br>Frontend:  <br>Der Zielgruppenfilter im Frontend der Anmeldetools für Treffen ermöglicht es Nutzern, gezielt Veranstaltungen zu finden, die ihren Interessen entsprechen. Durch einfache Auswahlmöglichkeiten wird der Zugang zu relevanten Treffen erleichtert, sodass jeder schnell die passenden Optionen entdecken kann.<br><br>Backend:<br><br>Für einen Zielgruppenfilter im Backend eines Anmeldetools werden Teilnehmerdaten erfasst und in der Datenbank gespeichert. Ein Algorithmus analysiert diese Daten und filtert Teilnehmer nach festgelegten Kriterien wie Interessen, Demografie oder Eventpräferenzen. Eine benutzerfreundliche Oberfläche ermöglicht das Erstellen und Anpassen von Zielgruppen. Zugriffsrechte sichern die Daten und stellen sicher, dass nur berechtigte Nutzer die Filter anwenden können. | AfT-5 |

## Profilverwaltung

| Profil erstellen<br><br>Frontend:  <br>Die Profilverwaltung im Frontend für Treffen erlaubt Nutzern, ein individuelles Profil zu erstellen, das ihre Interessen und Präferenzen widerspiegelt. Mit einfachen Eingabefeldern können sie persönliche Informationen und vergangene Veranstaltungen hinzufügen, um passende Treffen zu finden.<br><br>Backend:<br><br>Für die Profilverwaltung im Backend werden Eingabefelder für persönliche Informationen benötigt, die in einer Datenbank gespeichert werden. Ein Algorithmus validiert die Eingaben und stellt sicher, dass alle erforderlichen Daten korrekt erfasst werden. Zugriffsrechte sichern, dass nur autorisierte Nutzer Profile erstellen können, während eine Schnittstelle das Hinzufügen oder Bearbeiten von Profilen ermöglicht. | Pro-1 |
| --- | --- |
| Profil bearbeiten<br><br>Frontend:  <br>Die Profilbearbeitung im Frontend der Profilverwaltung für Treffen ermöglicht es Nutzern, ihre Informationen schnell und unkompliziert zu aktualisieren. Mit intuitiven Eingabefeldern können sie Interessen, persönliche Daten und vergangene Veranstaltungen anpassen, um stets ein aktuelles und relevantes Profil zu präsentieren.<br><br>Backend:<br><br>Für das Bearbeiten von Profilen im Backend werden Editierfunktionen und eine Datenbank benötigt, die die Änderungen speichert. Ein Algorithmus stellt sicher, dass nur gültige Eingaben übernommen werden. Zugriffsrechte kontrollieren, dass nur autorisierte Nutzer ihre eigenen Profile bearbeiten können. Eine benutzerfreundliche Schnittstelle ermöglicht das einfache Aktualisieren der Profilinformationen. | Pro-2 |
| Profil mit LinkedIn automatisch abgleichen lassen<br><br>Frontend:  <br>Die Funktion zum automatischen Abgleich des Profils mit LinkedIn im Frontend der Profilverwaltung für Treffen erleichtert Nutzern die Erstellung und Aktualisierung ihrer Informationen. Durch einen einfachen Klick werden relevante Daten wie berufliche Erfahrungen und Interessen nahtlos übernommen, sodass das Profil stets aktuell und ansprechend bleibt.<br><br>Backend:<br><br>Für den automatischen Abgleich mit LinkedIn wird eine API benötigt, die Profilinformationen aus LinkedIn abruft und in die Datenbank überträgt. Ein Algorithmus aktualisiert die Profildaten entsprechend. Zugriffsrechte stellen sicher, dass nur autorisierte Nutzer den Abgleich durchführen können. | Pro-3 |
| Profil verwaltung<br><br>Frontend:  <br>Die Profilverwaltung im Frontend für Treffen bietet Nutzern eine benutzerfreundliche Oberfläche, um ihre Informationen mühelos zu verwalten. Hier können sie persönliche Daten, Interessen und vergangene Veranstaltungen anpassen, um ein ansprechendes und relevantes Profil zu präsentieren, das ihre Teilnahme an zukünftigen Treffen optimiert.<br><br>Backend:<br><br>Für die Profilverwaltung im Backend werden eine Datenbank zur Speicherung der Profildaten, APIs zur Verwaltung und Aktualisierung dieser Informationen sowie Algorithmen zur Validierung der Eingaben benötigt. Eine Benutzeroberfläche ermöglicht das Bearbeiten und Anzeigen der Profile, während Zugriffsrechte sicherstellen, dass nur autorisierte Nutzer auf ihre eigenen Daten zugreifen oder Änderungen vornehmen können. | Pro-4 |

# Datenbank

| Datenbank<br><br>1. Zielsetzung
|Entwicklung einer relationalen Datenbank mit PostgreSQL zur Speicherung und Verwaltung von Anwendungsdaten.<br><br>2. Datenbankdesign<br><br>Datenmodellierung: Erstellung eines konzeptionellen Modells (z.B. ER-Diagramm) zur Definition der Entitäten, Attribute und Beziehungen. Tabellenstruktur: Definition der Tabellen, einschließlich: Primärschlüssel Fremdschlüssel Datentypen für jedes Attribute<br><br>3. Implementierung der Datenbank<br><br>Erstellung der Datenbank: Anlegen der PostgreSQL-Datenbank und der erforderlichen Tabellen. Indizes: Implementierung von Indizes zur Optimierung der Abfragegeschwindigkeit.Constraints: Festlegung von Constraints (z.B. NOT NULL, UNIQUE) zur Gewährleistung der Datenintegrität.<br><br>4. Datenbankanbindung<br><br>Zugriffsmethoden: Definition der Methoden zur Anbindung der Anwendung an die PostgreSQL-Datenbank (z.B. über JDBC, Entity Framework). CRUD-Operationen: Implementierung der grundlegenden CRUD-Operationen (Create, Read, Update, Delete) für die Datenmanipulation.<br><br>5. Sicherheit<br><br>Benutzerverwaltung: Einrichtung von Benutzerrollen und Berechtigungen zur Kontrolle des Zugriffs auf die Datenbank.Datenverschlüsselung: Implementierung von Maßnahmen zur Sicherstellung der Datensicherheit (z.B. SSL-Verbindungen). | DB-1 |
| --- | --- |

# Dokumentation

## Projektdokumentation

| Pflichtenheft | DOK-1 |
| --- | --- |
| Systembeschreibung | DOK-2 |
| Disasterrecovery Handbuch | DOK-3 |
| Benutzer Handbuch | DOK-4 |
| Admin Handbuch | DOK-5 |
| Git Handbuch | Dok-6 |